sh在.bashrc(代码片段)

author author     2022-12-19     556

关键词:

# ---------- Previous .bashrc ---------- #
# ~/.bashrc: executed by bash(1) for non-login shells.
# see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
# for examples

# If not running interactively, don't do anything
case $- in
    *i*) ;;
      *) return;;
esac

# don't put duplicate lines or lines starting with space in the history.
# See bash(1) for more options
HISTCONTROL=ignoreboth

# append to the history file, don't overwrite it
shopt -s histappend

# for setting history length see HISTSIZE and HISTFILESIZE in bash(1)
HISTSIZE=1000
HISTFILESIZE=2000

# check the window size after each command and, if necessary,
# update the values of LINES and COLUMNS.
shopt -s checkwinsize

# If set, the pattern "**" used in a pathname expansion context will
# match all files and zero or more directories and subdirectories.
#shopt -s globstar

# make less more friendly for non-text input files, see lesspipe(1)
[ -x /usr/bin/lesspipe ] && eval "$(SHELL=/bin/sh lesspipe)"

# set variable identifying the chroot you work in (used in the prompt below)
if [ -z "$debian_chroot:-" ] && [ -r /etc/debian_chroot ]; then
    debian_chroot=$(cat /etc/debian_chroot)
fi

# set a fancy prompt (non-color, unless we know we "want" color)
case "$TERM" in
    xterm-color|*-256color) color_prompt=yes;;
esac

# uncomment for a colored prompt, if the terminal has the capability; turned
# off by default to not distract the user: the focus in a terminal window
# should be on the output of commands, not on the prompt
#force_color_prompt=yes

if [ -n "$force_color_prompt" ]; then
    if [ -x /usr/bin/tput ] && tput setaf 1 >&/dev/null; then
	# We have color support; assume it's compliant with Ecma-48
	# (ISO/IEC-6429). (Lack of such support is extremely rare, and such
	# a case would tend to support setf rather than setaf.)
	color_prompt=yes
    else
	color_prompt=
    fi
fi

if [ "$color_prompt" = yes ]; then
    PS1='$debian_chroot:+($debian_chroot)\[\033[01;32m\]\u@\h\[\033[00m\]:\[\033[01;34m\]\w\[\033[00m\]\$ '
else
    PS1='$debian_chroot:+($debian_chroot)\u@\h:\w\$ '
fi
unset color_prompt force_color_prompt

# If this is an xterm set the title to user@host:dir
case "$TERM" in
xterm*|rxvt*)
    PS1="\[\e]0;$debian_chroot:+($debian_chroot)\u@\h: \w\a\]$PS1"
    ;;
*)
    ;;
esac

# enable color support of ls and also add handy aliases
if [ -x /usr/bin/dircolors ]; then
    test -r ~/.dircolors && eval "$(dircolors -b ~/.dircolors)" || eval "$(dircolors -b)"
    alias ls='ls --color=auto'
    #alias dir='dir --color=auto'
    #alias vdir='vdir --color=auto'

    alias grep='grep --color=auto'
    alias fgrep='fgrep --color=auto'
    alias egrep='egrep --color=auto'
fi

# colored GCC warnings and errors
#export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'

# some more ls aliases
alias ll='ls -alF'
alias la='ls -A'
alias l='ls -CF'

# Add an "alert" alias for long running commands.  Use like so:
#   sleep 10; alert
alias alert='notify-send --urgency=low -i "$([ $? = 0 ] && echo terminal || echo error)" "$(history|tail -n1|sed -e '\''s/^\s*[0-9]\+\s*//;s/[;&|]\s*alert$//'\'')"'

# Alias definitions.
# You may want to put all your additions into a separate file like
# ~/.bash_aliases, instead of adding them here directly.
# See /usr/share/doc/bash-doc/examples in the bash-doc package.

if [ -f ~/.bash_aliases ]; then
    . ~/.bash_aliases
fi

# enable programmable completion features (you don't need to enable
# this, if it's already enabled in /etc/bash.bashrc and /etc/profile
# sources /etc/bash.bashrc).
if ! shopt -oq posix; then
  if [ -f /usr/share/bash-completion/bash_completion ]; then
    . /usr/share/bash-completion/bash_completion
  elif [ -f /etc/bash_completion ]; then
    . /etc/bash_completion
  fi
fi

# ---------- New .bashrc ---------- #
#!/bin/bash
#
# DESCRIPTION:
#
#   Set the bash prompt according to:
#    * the active virtualenv
#    * the branch/status of the current git repository
#    * the return value of the previous command
#    * the fact you just came from Windows and are used to having newlines in
#      your prompts.
#
# USAGE:
#
#   1. Save this file as ~/.bash_prompt
#   2. Add the following line to the end of your ~/.bashrc or ~/.bash_profile:
#        . ~/.bash_prompt
#
# LINEAGE:
#
#   Based on work by woods
#
#   https://gist.github.com/31967

# The various escape codes that we can use to color our prompt.
        RED="\[\033[0;31m\]"
     YELLOW="\[\033[1;33m\]"
      GREEN="\[\033[0;32m\]"
       BLUE="\[\033[1;34m\]"
  LIGHT_RED="\[\033[1;31m\]"
LIGHT_GREEN="\[\033[1;32m\]"
      WHITE="\[\033[1;37m\]"
 LIGHT_GRAY="\[\033[0;37m\]"
 COLOR_NONE="\[\e[0m\]"

# Detect whether the current directory is a git repository.
function is_git_repository 
  git branch > /dev/null 2>&1


# Determine the branch/state information for this git repository.
function set_git_branch 
  # Capture the output of the "git status" command.
  git_status="$(git status 2> /dev/null)"

  # Set color based on clean/staged/dirty.
  if [[ $git_status =~ "working directory clean" ]]; then
    state="$GREEN"
  elif [[ $git_status =~ "Changes to be committed" ]]; then
    state="$YELLOW"
  else
    state="$LIGHT_RED"
  fi

  # Set arrow icon based on status against remote.
  remote_pattern="# Your branch is (ahead|behind)+ "
  if [[ $git_status =~ $remote_pattern ]]; then
    if [[ $BASH_REMATCH[1] == "ahead" ]]; then
      remote="↑"
    else
      remote="↓"
    fi
  else
    remote=""
  fi
  diverge_pattern="# Your branch and (.*) have diverged"
  if [[ $git_status =~ $diverge_pattern ]]; then
    remote="↕"
  fi

  # Get the name of the branch.
  branch_pattern="^(# )?On branch ([^$IFS]*)"
  commit_pattern="^(# )?HEAD detached at ([^$IFS]*)"
    if [[ $git_status =~ $branch_pattern ]]; then
      branch=$BASH_REMATCH[2]
    elif [[ $git_status =~ $commit_pattern ]]; then
      branch="($BASH_REMATCH[2]...)"
    fi

  # Set the final branch string.
  BRANCH="$state($branch)$remote$COLOR_NONE "


# Return the prompt symbol to use, colorized based on the return value of the
# previous command.
function set_prompt_symbol () 
  if test $1 -eq 0 ; then
      PROMPT_SYMBOL="\$"
  else
      PROMPT_SYMBOL="$LIGHT_RED\$$COLOR_NONE"
  fi


# Determine active Python virtualenv details.
function set_virtualenv () 
  if test -z "$VIRTUAL_ENV" ; then
      PYTHON_VIRTUALENV=""
  else
      PYTHON_VIRTUALENV="$BLUE[`basename \"$VIRTUAL_ENV\"`]$COLOR_NONE "
  fi


# Set the full bash prompt.
function set_bash_prompt () 
  # Set the PROMPT_SYMBOL variable. We do this first so we don't lose the
  # return value of the last command.
  set_prompt_symbol $?

  # Set the PYTHON_VIRTUALENV variable.
  set_virtualenv

  # Set the BRANCH variable.
  if is_git_repository ; then
    set_git_branch
  else
    BRANCH=''
  fi

  # Set the bash prompt variable.
  PS1="
$PYTHON_VIRTUALENV$GREEN\u@\h $YELLOW\w$COLOR_NONE $BRANCH
$PROMPT_SYMBOL "


# Tell bash to execute this function just before displaying its prompt.
PROMPT_COMMAND=set_bash_prompt


############################################################

# pipenv virtualenv in <working_dir>/.env/
export PIPENV_VENV_IN_PROJECT=1

sh在.bashrc(代码片段)

查看详情

sh我的控制台别名在.bashrc中(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh备份.bashrc(代码片段)

查看详情

sh的.bashrc(代码片段)

查看详情

sh.bashrc.virtualenvwrapper(代码片段)

查看详情

sh安装shskwmt的bashrc(代码片段)

查看详情

sh个人bashrc个人资料-别名(代码片段)

查看详情

sh我真棒.bashrc-随意偷东西(代码片段)

查看详情

bashrc和bash_profile(代码片段)

在~/.bashrc中起别名!/bin/bash下必须加上shopt-sexpand_aliases#!/bin/sh下不用shopt-sexpand_aliases这一条命令让shell脚本中的alias可以使用。但是经测试,在#!/bin/sh下,该命令可有可无,不影响alias的使用,在!/bin/bash下,才有影响。~/.bash_profile中... 查看详情